﻿using System;
using System.Collections.Generic;
using System.Security.Cryptography;
using System.Data;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Runtime.InteropServices;
using System.Threading;
using System.Windows.Forms;

namespace MagicGED
{
    public partial class Main : Form
    {
        string[] ACCEPT_EXTENSIONS = { ".doc", ".docx", ".rtf", ".xls", ".xlsx", ".pdf", ".ppt", ".pptx", ".txt", ".sql", ".png", ".jpg", ".jpeg", ".gif", ".bmp", ".msg", ".htm", ".html", ".xml" };
        string OFD_FILTER = "Word files|*.doc;*.docx;*.rtf|Excel files|*.xls;*.xlsx|Adobe Reader|*.pdf|Power Point|*.ppt;*.pptx|Text file|*.txt|SQL File|*.sql|Picture|*.png;*.jpg;*.jpeg;*.gif;*.bmp|Email message|*.msg|HTML File|*.htm;*.html|XML File|*.xml";

        public Main()
        {
            InitializeComponent();
            InitializeForm();
        }

        private void quitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void indexAFolderToolStripMenuItem_Click(object sender, EventArgs e)
        {
            FolderBrowserDialog fbd = new FolderBrowserDialog();
            fbd.Description = "Type a folder to index";
            fbd.ShowNewFolderButton = false;
            if (fbd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                if (Directory.Exists(fbd.SelectedPath))
                {
                    using (SqlConnection cnx = new SqlConnection(@"Server=.\SQLEXPRESS;Database=MagicGED;Trusted_Connection=True;"))
                    {
                        cnx.Open();
                        using (SqlTransaction trans = cnx.BeginTransaction(IsolationLevel.ReadCommitted))
                        {
                            using (SqlCommand cmdIns = cnx.CreateCommand())
                            {
                                cmdIns.Transaction = trans;
                                cmdIns.CommandText = "insert into document (title, extension, doc) output inserted.id values (@title, @extension, 0x0)";
                                SqlParameter pTitle = cmdIns.CreateParameter();
                                pTitle.ParameterName = "title";
                                pTitle.SqlDbType = SqlDbType.NVarChar;
                                pTitle.Size = 256;
                                cmdIns.Parameters.Add(pTitle);
                                SqlParameter pExtension = cmdIns.CreateParameter();
                                pExtension.ParameterName = "extension";
                                pExtension.SqlDbType = SqlDbType.NVarChar;
                                pExtension.Size = 8;
                                cmdIns.Parameters.Add(pExtension);

                                using (SqlCommand cmdSel = cnx.CreateCommand())
                                {
                                    cmdSel.Transaction = trans;
                                    cmdSel.CommandText = "select doc.PathName(), GET_FILESTREAM_TRANSACTION_CONTEXT() from document where id = @id";
                                    SqlParameter pId = cmdSel.CreateParameter();
                                    pId.ParameterName = "id";
                                    pId.SqlDbType = SqlDbType.UniqueIdentifier;
                                    cmdSel.Parameters.Add(pId);

                                    DirectoryInfo di = new DirectoryInfo(fbd.SelectedPath);
                                    FileInfo[] files = di.GetFiles("*.*", SearchOption.AllDirectories);

                                    toolStripProgressBar1.Value = 0;
                                    toolStripProgressBar1.Minimum = 0;
                                    toolStripProgressBar1.Maximum = files.Length;
                                    toolStripProgressBar1.Visible = true;

                                    foreach (FileInfo fsi in files)
                                    {
                                        bool ignore = true;
                                        for (int i = 0, len = ACCEPT_EXTENSIONS.Length; i < len; i++)
                                        {
                                            if (ACCEPT_EXTENSIONS[i] == fsi.Extension.ToLower())
                                            {
                                                ignore = false;
                                                break;
                                            }
                                        }

                                        if (!ignore)
                                        {
                                            pTitle.Value = fsi.Name;
                                            pExtension.Value = fsi.Extension.ToLower();
                                            pId.Value = cmdIns.ExecuteScalar();
                                            
                                            using (SqlDataReader dr = cmdSel.ExecuteReader(CommandBehavior.SingleResult | CommandBehavior.SingleRow | CommandBehavior.SequentialAccess))
                                            {
                                                dr.Read();
                                                string path = dr.GetString(0);
                                                byte[] tc = dr.GetSqlBytes(1).Buffer;

                                                byte[] b = new byte[1048576];

                                                using (SqlFileStream sfs = new SqlFileStream(path, tc, FileAccess.Write, FileOptions.SequentialScan, 0))
                                                {
                                                    using (FileStream fs = new FileStream(fsi.FullName, FileMode.Open, FileAccess.Read, FileShare.Read))
                                                    {
                                                        int l = 0;

                                                        while ((l = fs.Read(b, 0, b.Length)) > 0)
                                                        {
                                                            sfs.Write(b, 0, l);
                                                        }

                                                        fs.Close();
                                                    }
                                                    sfs.Close();
                                                }
                                            }
                                            
                                        }
                                        toolStripProgressBar1.Value++;
                                        statusStrip1.Refresh();
                                    }
                                }
                            }
                            trans.Commit();
                        }
                        cnx.Close();
                    }
                    InitializeForm();
                }
                else
                {
                    MessageBox.Show("The folder you specified doesn't exist", "Folder doesn't exist", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }

        private void InitializeForm()
        {
            comboBox1.Items.Clear();
            listView1.Items.Clear();
            toolStripProgressBar1.Visible = false;
            comboBox1.Items.Add("*.*");
            comboBox1.SelectedIndex = 0;
            using (SqlConnection cnx = new SqlConnection(@"Server=.\SQLEXPRESS;Database=MagicGED;Trusted_Connection=True;"))
            {
                cnx.Open();
                using (SqlCommand cmd = cnx.CreateCommand())
                {
                    cmd.CommandText = "select count(*) from document";
                    toolStripStatusLabel1.Text = string.Format("Documents count : {0}", (int)cmd.ExecuteScalar());

                    cmd.CommandText = "select distinct extension from document";
                    using (SqlDataReader dr = cmd.ExecuteReader(CommandBehavior.SingleResult | CommandBehavior.SequentialAccess))
                    {
                        while (dr.Read())
                        {
                            comboBox1.Items.Add(string.Format("*{0}", dr.GetString(0)));
                        }
                        dr.Close();
                    }
                }
                cnx.Close();
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            listView1.Items.Clear();
            imageList1.Images.Clear();
            imageList2.Images.Clear();

            listView1.Refresh();
            toolStripStatusLabel1.Text = "Searching in documents...";
            statusStrip1.Refresh();

            this.SuspendLayout();
            listView1.SuspendLayout();
            
            int found = 0;

            using (SqlConnection cnx = new SqlConnection(@"Server=.\SQLEXPRESS;Database=MagicGED;Trusted_Connection=True;"))
            {
                cnx.Open();
                using (SqlCommand cmd = cnx.CreateCommand())
                {
                    cmd.CommandText = "select id, title, extension from document where contains((title, doc), @word)";
                    SqlParameter pWord = cmd.CreateParameter();
                    pWord.ParameterName = "word";
                    pWord.Size = textBox1.Text.Length;
                    pWord.SqlDbType = SqlDbType.NVarChar;
                    pWord.Value = textBox1.Text;
                    cmd.Parameters.Add(pWord);

                    if ((string)comboBox1.SelectedItem != "*.*")
                    {
                        cmd.CommandText = cmd.CommandText + " and extension = @extension";
                        SqlParameter pExtension = cmd.CreateParameter();
                        pExtension.ParameterName = "extension";
                        pExtension.Size = 8;
                        pExtension.SqlDbType = SqlDbType.NVarChar;
                        pExtension.Value = ((string)comboBox1.SelectedItem).Substring(1);
                        cmd.Parameters.Add(pExtension);
                    }

                    SqlDataAdapter da = new SqlDataAdapter(cmd);
                    DataTable dt = new DataTable();
                    
                    try
                    {
                        da.Fill(dt);
                    }
                    catch (SqlException ex)
                    {
                        MessageBox.Show(string.Format("An error occured\n\nCode : {0}\nMessage : {1}", ex.ErrorCode, ex.Message), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1);
                        cnx.Close();
                        return;
                    }

                    foreach (DataRow dr in dt.Rows)
                    {
                        found++;
                        FileListObject file = new FileListObject(dr, imageList1, imageList2);
                        ListViewItem item = new ListViewItem();
                        item.Text = file.Filename;
                        item.ImageIndex = file.Icon;
                        item.Tag = file.ID;
                        listView1.Items.Add(item);
                    }
                    
                }
                cnx.Close();
            }

            switch(found)
            {
                case 0:
                    toolStripStatusLabel1.Text = "No document found";
                    break;
                case 1:
                    toolStripStatusLabel1.Text = "1 document found";
                    break;
                default:
                    toolStripStatusLabel1.Text = string.Format("{0} documents found", found);
                    break;
            }

            listView1.ResumeLayout();
            this.ResumeLayout();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            listView1.View = View.LargeIcon;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            listView1.View = View.List;
        }

        private void listView1_DoubleClick(object sender, EventArgs e)
        {
            if (listView1.SelectedItems.Count == 0) return;

            Guid id = (Guid)listView1.SelectedItems[0].Tag;
            string temp = string.Empty;

            using (SqlConnection cnx = new SqlConnection(@"Server=.\SQLEXPRESS;Database=MagicGED;Trusted_Connection=True;"))
            {
                cnx.Open();
                using (SqlTransaction trans = cnx.BeginTransaction(IsolationLevel.ReadCommitted))
                {
                    using (SqlCommand cmd = cnx.CreateCommand())
                    {
                        cmd.Transaction = trans;
                        cmd.CommandText = "select doc.PathName(), GET_FILESTREAM_TRANSACTION_CONTEXT (), extension from document where id = @id";
                        SqlParameter pId = cmd.CreateParameter();
                        pId.ParameterName = "id";
                        pId.SqlDbType = SqlDbType.UniqueIdentifier;
                        pId.Value = id;
                        cmd.Parameters.Add(pId);

                        using (SqlDataReader dr = cmd.ExecuteReader(CommandBehavior.SequentialAccess | CommandBehavior.SingleResult | CommandBehavior.SingleRow))
                        {
                            if (dr.Read())
                            {
                                string path = dr.GetString(0);
                                byte[] tc = dr.GetSqlBytes(1).Buffer;

                                temp = Path.ChangeExtension(Path.GetTempFileName(), dr.GetString(2).Substring(1));

                                byte[] b = new byte[1048576];

                                using (SqlFileStream fsi = new SqlFileStream(path, tc, FileAccess.Read, FileOptions.SequentialScan, 0))
                                {
                                    using (FileStream fso = new FileStream(temp, FileMode.CreateNew, FileAccess.Write, FileShare.None))
                                    {
                                        int l = 0;

                                        while ((l = fsi.Read(b, 0, b.Length)) > 0)
                                        {
                                            fso.Write(b, 0, l);
                                        }

                                        fso.Close();
                                    }
                                    fsi.Close();
                                }

                            }
                            else
                            {
                                throw new Exception("Unexpected exception : data can't be read");
                            }
                        }
                    }
                    trans.Commit();
                }
                cnx.Close();
            }

            if (temp.Length > 0)
            {
                byte[] checksum1 = null;
                byte[] checksum2 = null;

                using (FileStream s = new FileStream(temp, FileMode.Open, FileAccess.Read, FileShare.Read))
                {
                    MD5CryptoServiceProvider md5 = new MD5CryptoServiceProvider();
                    checksum1 = md5.ComputeHash(s);
                }

                ProcessStartInfo psi = new ProcessStartInfo(temp);
                Process p = new Process();
                p.StartInfo = psi;
                if (p.Start())
                {
                    p.WaitForExit();

                    using (FileStream s = new FileStream(temp, FileMode.Open, FileAccess.Read, FileShare.Read))
                    {
                        MD5CryptoServiceProvider md5 = new MD5CryptoServiceProvider();
                        checksum2 = md5.ComputeHash(s);
                    }

                    bool modified = false;
                    if (checksum1.Length != checksum2.Length)
                    {
                        modified = true;
                    }
                    else
                    {
                        for (int i = 0, len = checksum1.Length; i < len; i++)
                        {
                            if (checksum1[i] != checksum2[i])
                            {
                                modified = true;
                                break;
                            }
                        }
                    }

                    if (modified && MessageBox.Show("Le fichier a été modifé. Voulez-vous l'enregistrer ?", "Enregistrer les modifications ?", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1) == System.Windows.Forms.DialogResult.Yes)
                    {
                        using (SqlConnection cnx = new SqlConnection(@"Server=.\SQLEXPRESS;Database=MagicGED;Trusted_Connection=True;"))
                        {
                            cnx.Open();
                            using (SqlTransaction trans = cnx.BeginTransaction(IsolationLevel.ReadCommitted))
                            {
                                using (SqlCommand cmd = cnx.CreateCommand())
                                {
                                    cmd.Transaction = trans;
                                    cmd.CommandText = "insert into archive (doc_id, user_id, archive_date, doc) select doc_id, user_id, GetDate(), doc from document where id = @id";
                                    SqlParameter pId = cmd.CreateParameter();
                                    pId.ParameterName = "id";
                                    pId.SqlDbType = SqlDbType.UniqueIdentifier;
                                    pId.Value = id;
                                    cmd.Parameters.Add(pId);
                                    cmd.ExecuteNonQuery();
                                    
                                    cmd.CommandText = "select doc.PathName(), GET_FILESTREAM_TRANSACTION_CONTEXT (), extension from document where id = @id";

                                    using (SqlDataReader dr = cmd.ExecuteReader(CommandBehavior.SingleResult | CommandBehavior.SingleRow | CommandBehavior.SequentialAccess))
                                    {
                                        dr.Read();
                                        string path = dr.GetString(0);
                                        byte[] tc = dr.GetSqlBytes(1).Buffer;

                                        byte[] b = new byte[1048576];

                                        using (SqlFileStream sfs = new SqlFileStream(path, tc, FileAccess.Write, FileOptions.SequentialScan, 0))
                                        {
                                            using (FileStream fs = new FileStream(temp, FileMode.Open, FileAccess.Read, FileShare.Read))
                                            {
                                                int l = 0;

                                                while ((l = fs.Read(b, 0, b.Length)) > 0)
                                                {
                                                    sfs.Write(b, 0, l);
                                                }

                                                fs.Close();
                                            }
                                            sfs.Close();
                                        }
                                    }
                                }
                                trans.Commit();
                            }
                            cnx.Close();
                        }
                    }
                }
                else
                {
                    MessageBox.Show("Can't start the program");
                }

                bool deleted = false;
                while (!deleted)
                {
                    try
                    {
                        File.Delete(temp);
                        deleted = true;
                    }
                    catch
                    {
                        Thread.Sleep(100);
                    }
                }
            }
        }

        private void newDocumentToolStripMenuItem_Click(object sender, EventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.AutoUpgradeEnabled = true;
            ofd.AddExtension = true;
            ofd.CheckFileExists = true;
            ofd.CheckPathExists = true;
            ofd.Filter = OFD_FILTER;
            ofd.Multiselect = true;
            ofd.Title = "Choose a document";

            if (ofd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                using (SqlConnection cnx = new SqlConnection(@"Server=.\SQLEXPRESS;Database=MagicGED;Trusted_Connection=True;"))
                {
                    cnx.Open();
                    using (SqlTransaction trans = cnx.BeginTransaction(IsolationLevel.ReadCommitted))
                    {
                        using (SqlCommand cmdIns = cnx.CreateCommand())
                        {
                            cmdIns.Transaction = trans;
                            cmdIns.CommandText = "insert into document (title, extension, doc) output inserted.id values (@title, @extension, 0x0)";
                            SqlParameter pTitle = cmdIns.CreateParameter();
                            pTitle.ParameterName = "title";
                            pTitle.SqlDbType = SqlDbType.NVarChar;
                            pTitle.Size = 256;
                            cmdIns.Parameters.Add(pTitle);
                            SqlParameter pExtension = cmdIns.CreateParameter();
                            pExtension.ParameterName = "extension";
                            pExtension.SqlDbType = SqlDbType.NVarChar;
                            pExtension.Size = 10;
                            cmdIns.Parameters.Add(pExtension);

                            using (SqlCommand cmdSel = cnx.CreateCommand())
                            {
                                cmdSel.Transaction = trans;
                                cmdSel.CommandText = "select doc.PathName(), GET_FILESTREAM_TRANSACTION_CONTEXT() from document where id = @id";
                                SqlParameter pId = cmdSel.CreateParameter();
                                pId.ParameterName = "id";
                                pId.SqlDbType = SqlDbType.UniqueIdentifier;
                                cmdSel.Parameters.Add(pId);

                                string[] files = ofd.FileNames;

                                toolStripProgressBar1.Value = 0;
                                toolStripProgressBar1.Minimum = 0;
                                toolStripProgressBar1.Maximum = files.Length;
                                toolStripProgressBar1.Visible = true;

                                foreach (string f in files)
                                {
                                    FileInfo fsi = new FileInfo(f);

                                    pTitle.Value = fsi.Name;
                                    pExtension.Value = fsi.Extension.ToLower();
                                    pId.Value = cmdIns.ExecuteScalar();

                                    using (SqlDataReader dr = cmdSel.ExecuteReader(CommandBehavior.SingleResult | CommandBehavior.SingleRow | CommandBehavior.SequentialAccess))
                                    {
                                        dr.Read();
                                        string path = dr.GetString(0);
                                        byte[] tc = dr.GetSqlBytes(1).Buffer;

                                        byte[] b = new byte[1048576];

                                        using (SqlFileStream sfs = new SqlFileStream(path, tc, FileAccess.Write, FileOptions.SequentialScan, 0))
                                        {
                                            using (FileStream fs = new FileStream(fsi.FullName, FileMode.Open, FileAccess.Read, FileShare.Read))
                                            {
                                                int l = 0;

                                                while ((l = fs.Read(b, 0, b.Length)) > 0)
                                                {
                                                    sfs.Write(b, 0, l);
                                                }

                                                fs.Close();
                                            }
                                            sfs.Close();
                                        }
                                    }
                                    toolStripProgressBar1.Value++;
                                    statusStrip1.Refresh();
                                }
                            }
                        }
                        trans.Commit();
                    }
                    cnx.Close();
                }
                InitializeForm();
            }
        }
    }

    class FileListObject
    {
        public Guid ID = Guid.Empty;
        public string Filename = string.Empty;
        string Extension = string.Empty;
        public int Icon = 0;

        public FileListObject(DataRow dr, ImageList small, ImageList large)
        {
            ID = (Guid)dr["id"];
            Filename = (string)dr["title"];
            Extension = (string)dr["extension"];
            Icon = small.Images.Count;

            IntPtr hImgSmall;
            IntPtr hImgLarge;

            SHFILEINFO shinfo = new SHFILEINFO();

            hImgSmall = Win32.SHGetFileInfo(Extension, 0, out shinfo, (uint)Marshal.SizeOf(shinfo), Win32.SHGFI_ICON | Win32.SHGFI_USEFILEATTRIBUTES | Win32.SHGFI_SMALLICON);
            small.Images.Add(System.Drawing.Icon.FromHandle(shinfo.hIcon));

            hImgLarge = Win32.SHGetFileInfo(Extension, 0, out shinfo, (uint)Marshal.SizeOf(shinfo), Win32.SHGFI_ICON | Win32.SHGFI_USEFILEATTRIBUTES | Win32.SHGFI_LARGEICON);
            large.Images.Add(System.Drawing.Icon.FromHandle(shinfo.hIcon));
        }
    }

    [StructLayout(LayoutKind.Sequential)]
    public struct SHFILEINFO
    {
        public IntPtr hIcon;
        public IntPtr iIcon;
        public uint dwAttributes;
        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 260)]
        public string szDisplayName;
        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 80)]
        public string szTypeName;
    }

    class Win32
    {
        public const uint SHGFI_ICON = 0x100;
        public const uint SHGFI_LARGEICON = 0x0;    // 'Large icon
        public const uint SHGFI_SMALLICON = 0x1;    // 'Small icon
        public const uint SHGFI_USEFILEATTRIBUTES = 0x10;

        [DllImport("shell32.dll")]
        public static extern IntPtr SHGetFileInfo(string pszPath,
                                    uint dwFileAttributes,
                                    out SHFILEINFO psfi,
                                    uint cbSizeFileInfo,
                                    uint uFlags);
    }
}
